SystemOrganization addCategory: #'Cutie-Helvetia-Examples'!

QQTestCase subclass: #CUAssociationExample
	instanceVariableNames: 'other'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Examples'!

!CUAssociationExample class methodsFor: 'transformations' stamp: 'lr 4/26/2010 23:14'!
translateReleation
	<transform>
	
	^ CHConditionPattern new
		if: [ :context | context hasPragmaNamed: #opposite: ]
		then: (CHTreePattern new
			method: '`method: `argument `variable := `argument'
			do: [ :context |
				| opposite variable |
				opposite := (context pragmaNamed: #opposite:)
					arguments first.
				variable := context @ '`variable'.
				context tree body addNodeFirst: ``(`,(variable) isNil 
					ifFalse: [ `,(variable) instVarNamed: `,(opposite) put: nil ]).
				context tree body addNode: ``(`,(variable) isNil
					ifFalse: [ `,(variable) instVarNamed: `,(opposite) put: self ]) ])! !

!CUAssociationExample methodsFor: 'accessing' stamp: 'lr 8/19/2008 13:38'!
other
	^ other! !

!CUAssociationExample methodsFor: 'accessing' stamp: 'lr 8/19/2008 13:39'!
other: anObject
	<opposite: 'other'>

	other := anObject! !

!CUAssociationExample methodsFor: 'testing' stamp: 'lr 8/19/2008 13:39'!
testEmpty
	| test |
	test := self copy.
	self assert: self other isNil.
	self assert: test other isNil.! !

!CUAssociationExample methodsFor: 'testing' stamp: 'lr 4/26/2010 23:13'!
testNil
	| test |
	test := self copy.
	test other: self.
	self other: nil.
	self assert: self other isNil.
	self assert: test other isNil! !

!CUAssociationExample methodsFor: 'testing' stamp: 'lr 4/26/2010 23:14'!
testOpposite
	| test |
	test := self copy.
	test other: self.
	self assert: self other == test.
	self assert: test other == self! !

!CUAssociationExample methodsFor: 'testing' stamp: 'lr 4/26/2010 23:14'!
testSwap
	| test1 test2 |
	test1 := self copy.
	self other: test1.
	test2 := self copy.
	self other: test2.
	self assert: self other = test2.
	self assert: test1 other isNil.
	self assert: test2 other = self! !

!CUAssociationExample methodsFor: 'testing' stamp: 'lr 4/26/2010 23:14'!
testThis
	| test |
	test := self copy.
	self other: test.
	self assert: self other = test.
	self assert: test other = self! !

QQTestCase subclass: #CUCastingExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Examples'!

!CUCastingExample class methodsFor: 'transformations' stamp: 'lr 5/3/2010 22:37'!
transformCast
	<transform>

	^ CHTreePattern new
		expression: '(``@obj cast: `literal) `@msg: ``@args'
		do: [ :context |
			context node swapWith: ``(`,(context node receiver receiver)
				perform: `,(context node selector)
				withArguments: { `,(context node arguments) }
				inSuperclass: `,(context node receiver arguments first)) ];
		yourself! !

!CUCastingExample class methodsFor: 'transformations' stamp: 'lr 5/3/2010 22:37'!
transformThis
	<transform>

	^ Array
		with: (CHTreePattern new
			expression: 'this `@msg: ``@args' do: [ :context |
				context node swapWith: ``(self
					perform: `,(context node selector)
					withArguments: { `,(context node arguments) }
					inSuperclass: `,(context theClass)) ];
			yourself)
		with: (CHTreePattern new
			expression: 'this' 
			do: [ :context | context node swapWith: ``(self) ];
			yourself)! !

!CUCastingExample methodsFor: 'testing-cast' stamp: 'lr 5/3/2010 22:37'!
testBinaryCast
	| point1 point2 |
	point1 := 1 @ 2.
	point2 := 1 @ 2.
	self assert: point1 = point2.
	self deny: (point1 cast: Object) = point2! !

!CUCastingExample methodsFor: 'testing-this' stamp: 'lr 5/3/2010 22:37'!
testEqualityThis
	self assert: self == super.
	self assert: super == self.

	self assert: self == this.
	self assert: this == self.
	
	self assert: super == this.
	self assert: this == super! !

!CUCastingExample methodsFor: 'testing-cast' stamp: 'lr 5/3/2010 22:37'!
testKeywordCast
	| point |
	point := 1 @ 2.
	self assert: (String streamContents: [ :stream |
		point printOn: stream ]) = '1@2'.
	self assert: (String streamContents: [ :stream |
		(point cast: Object) printOn: stream ]) = 'a Point'! !

!CUCastingExample methodsFor: 'testing-cast' stamp: 'lr 5/3/2010 22:37'!
testUnaryCast
	| point |
	point := 1 @ 2.
	self assert: (point hash) ~= point identityHash.
	self assert: (point cast: Object) hash = point identityHash! !

QQTestCase subclass: #CUControlExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Examples'!

!CUControlExample class methodsFor: 'transformation' stamp: 'lr 4/2/2009 15:28'!
transformIf
	<transform>

	^ CHTreePattern new
		expression: '`@statement if: `@boolean' do: [ :context |
			| statement condition |
			statement := context @ '`@statement'.
			statement isBlock
				ifFalse: [ statement := ``[ `,statement ] ].
			condition := context @ '`@boolean'.
			context node swapWith: ``(`,condition
				ifTrue: `,statement) ];
		yourself! !

!CUControlExample methodsFor: 'tests' stamp: 'lr 2/25/2009 09:45'!
testWithBlock
	| marker |

	[ marker := 1 ] if: true.
	self assert: marker = 1.
	
	[ marker := 2 ] if: false.
	self assert: marker = 1
! !

!CUControlExample methodsFor: 'tests' stamp: 'lr 2/25/2009 09:46'!
testWithoutBlock
	| marker |

	(marker := 1) if: true.
	self assert: marker = 1.
	
	(marker := 2) if: false.
	self assert: marker = 1
! !

QQTestCase subclass: #CUExpandExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Examples'!

!CUExpandExample class methodsFor: 'transformations' stamp: 'lr 8/13/2008 13:42'!
expand: aNode arguments: aNodeArray
	| stream parts string char index argument |
	aNode value isEmpty
		ifTrue: [ ^ aNode ].
	stream := aNode value readStream.
	parts := OrderedCollection new.
	[ stream atEnd ] whileFalse: [
		string := stream upTo: $<.
		string isEmpty
			ifFalse: [ parts add: string lift ].
		stream atEnd ifFalse: [
			char := stream next asUppercase.
			char = $N 
				ifTrue: [ parts add: ``(String cr) ].
			char = $T 
				ifTrue: [ parts add: ``(String tab) ].
			char isDigit ifTrue: [
				index := char digitValue.
				[ stream atEnd or: [ (char := stream next asUppercase) isDigit not ] ] 
					whileFalse: [ index := index * 10 + char digitValue ].
				argument := aNodeArray
					at: index 
					ifAbsent: [ self error: 'Invalid argument' ].
				char = $? ifTrue: [
					parts add: ``(`,argument
						ifTrue: [ `,(stream upTo: $:) ] 
						ifFalse: [ `,(stream upTo: $>) ]).
					stream skip: -1 ].
				char = $P
					ifTrue: [ parts add: ``(`,argument printString) ].
				char = $S
					ifTrue: [ parts add: argument ] ].
			stream skipTo: $> ] ].
	^ parts fold: [ :a :b | ``(`,a , `,b) ]! !

!CUExpandExample class methodsFor: 'transformations' stamp: 'lr 9/18/2008 11:17'!
flattenChain: aNode to: aCollection
	(aNode isMessage and: [ aNode isBinary ])
		ifFalse: [ aCollection add: aNode ]
		ifTrue: [
			self flattenChain: aNode receiver to: aCollection.
			aCollection add: aNode arguments first ].
	^ aCollection! !

!CUExpandExample class methodsFor: 'transformations' stamp: 'lr 9/3/2010 13:21'!
transformExpand
	<transform>

	^ CHTreePattern new
		expression: '`#literal << `@arguments' do: [ :context |
			| node |
			node := context scopedTree.
			context scopedTree swapWith: (self
				expand: node receiver
				arguments: (self 
					flattenChain: node arguments first
					to: OrderedCollection new)) ];
		yourself! !

!CUExpandExample class methodsFor: 'transformations' stamp: 'lr 4/2/2009 15:28'!
transformHighlight
	<highlight>

	^ CHTreePattern new
		expression: '`#literal << `@arguments';
		at: '`#literal' do: (CHMatchPattern new
			expression: '<([^>]+)>' do: TextEmphasis italic;
			yourself);
		yourself! !

!CUExpandExample methodsFor: 'testing' stamp: 'lr 2/25/2009 09:46'!
testBoolean
	self assert: '<1?yes:no>' << true = 'yes'.
	self assert: 'a<1?yes:no>' << false = 'ano'.
	self assert: '<1?yes:no>a' << true = 'yesa'.
	self assert: 'a<1?yes:no>b' << false = 'anob'! !

!CUExpandExample methodsFor: 'testing' stamp: 'lr 8/13/2008 13:16'!
testEmpty
	self assert: '<t>' << nil = String tab! !

!CUExpandExample methodsFor: 'testing' stamp: 'lr 8/13/2008 13:14'!
testExample
	self assert: '<1s> owns <2p> pair<3?s:>' << ('Hans' , 1 , false) = 'Hans owns 1 pair'.
	self assert: '<1s> owns <2p> pair<3?s:>' << ('Kurt' , 2 , true) = 'Kurt owns 2 pairs'! !

!CUExpandExample methodsFor: 'testing' stamp: 'lr 8/13/2008 13:16'!
testNewLine
	self assert: '<n>' << nil = String cr.! !

!CUExpandExample methodsFor: 'testing' stamp: 'lr 8/13/2008 13:15'!
testPrint
	self assert: '<1p>' << 1 = '1'.
	self assert: 'a<1p>' << 2 = 'a2'.
	self assert: '<1p>a' << 3 = '3a'.
	self assert: 'a<1p>b' << 4 = 'a4b'! !

!CUExpandExample methodsFor: 'testing' stamp: 'lr 8/13/2008 13:15'!
testString
	self assert: '<1s>' << 'x' = 'x'.
	self assert: 'a<1s>' << 'y' = 'ay'.
	self assert: '<1s>a' << 'z' = 'za'.
	self assert: 'a<1s>b' << ' ' = 'a b'! !

!CUExpandExample methodsFor: 'testing' stamp: 'lr 8/13/2008 13:16'!
testTab
	self assert: '<t>' << nil = String tab! !

QQTestCase subclass: #CUFutureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Examples'!

!CUFutureTest class methodsFor: 'transformations' stamp: 'lr 9/11/2010 13:44'!
highlighting
	<highlight>

	^ Array 
		with: (CHTreePattern new
			expression: '(``@receiver future) `@message: ``@arguments' do: TextEmphasis underlined;
			yourself)
		with: (CHTreePattern new
			expression: '(``@receiver future: `@delay) `@message: ``@arguments' do: TextEmphasis underlined;
			yourself)! !

!CUFutureTest class methodsFor: 'transformations' stamp: 'lr 9/3/2010 13:35'!
transformation
	<transform>

	^ Array 
		with: (CHTreePattern new
			expression: '(``@receiver future) `@message: ``@arguments' do: [ :context |
				context scopedTree swapWith: ``(self 
					future: 0 
					receiver: `,(context @ '``@receiver')
					perform: `,(context @ '`@message:')
					arguments: { `,(context @ '``@arguments') }) ];
			yourself)
		with: (CHTreePattern new
			expression: '(``@receiver future: `@delay) `@message: ``@arguments' do: [ :context |
				context scopedTree swapWith: ``(self
					future: `,(context @ '`@delay')
					receiver: `,(context @ '``@receiver')
					perform: `,(context @ '`@message:')
					arguments: { `,(context @ '``@arguments') }) ];
			yourself)! !

!CUFutureTest methodsFor: 'utilities' stamp: 'lr 9/3/2010 13:49'!
future: anInteger receiver: anObject perform: aSelector arguments: anArray
	[ anInteger > 0
		ifTrue: [ (Delay forMilliseconds: anInteger) wait ].
	  anObject perform: aSelector withArguments: anArray ]
		forkNamed: 'future'.
	^ nil! !

!CUFutureTest methodsFor: 'testing' stamp: 'lr 9/3/2010 13:49'!
testMorph
	| morph |
	morph := CircleMorph new.
	morph color: Color red.
	morph openInWorld.

	(morph future: 1000) color: Color orange.
	(morph future: 2000) color: Color green.
	(morph future: 3000) delete! !

!CUFutureTest methodsFor: 'testing' stamp: 'lr 9/3/2010 13:38'!
testNow
	| holder |
	holder := ValueHolder new.
	holder contents: false.
	holder future contents: true.
	(Delay forMilliseconds: 10)
		wait.
	self assert: holder contents! !

!CUFutureTest methodsFor: 'testing' stamp: 'lr 9/3/2010 13:48'!
testThen
	| holder |
	holder := ValueHolder new.
	holder contents: false.
	(holder future: 10)
		contents: true.
	self deny: holder contents.
	(Delay forMilliseconds: 20)
		wait.
	self assert: holder contents! !

QQTestCase subclass: #CUInterpolateExample
	instanceVariableNames: 'instVar'
	classVariableNames: 'ClassVar'
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Examples'!

!CUInterpolateExample class methodsFor: 'transformations' stamp: 'lr 8/13/2008 13:42'!
interpolate: aString
	| stream parts string |
	aString isEmpty
		ifTrue: [ ^ aString lift ].
	stream := aString readStream.
	parts := OrderedCollection new.
	[ stream atEnd ] whileFalse: [
		string := stream upTo: ${.
		string isEmpty 
			ifFalse: [ parts add: (string lift adjustBy: stream position - string size + 1) ].
		string := stream upTo: $}.
		string isEmpty
			ifFalse: [ 
				parts add: (``(`,(QQParser parseExpression: string) asString)
					adjustBy: stream position - string size + 1)  ] ].
	^ parts fold: [ :a :b | ``(`,a , `,b) ]! !

!CUInterpolateExample class methodsFor: 'transformations' stamp: 'lr 4/2/2009 21:25'!
transformHighlight
	<highlight>

	^ CHTreePattern new
		verification: [ :node | node value isString and: [ node value isSymbol not ] ];
		expression: '`#literal' do: (CHRangePattern new
			begin: '{' do: Color black;
			end: '}' do: Color black;
			outer: (CHHighlightAttribute new
				color: (Color lightGray alpha: 0.25);
				yourself);
			inner: Color gray muchDarker;
			yourself);
		yourself! !

!CUInterpolateExample class methodsFor: 'transformations' stamp: 'lr 4/2/2009 15:28'!
transformInterpolate
	<transform>

	^ CHTreePattern new
		verification: [ :node | node value isString and: [ node value isSymbol not ] ];
		expression: '`#literal' do: [ :context | 
			context node swapWith: (self interpolate: context node value) ];
		yourself! !

!CUInterpolateExample methodsFor: 'utilities' stamp: 'lr 5/26/2008 15:37'!
owner: owner object: object count: count
	^ '{owner} owns {count} {object asPluralBasedOn: count}'! !

!CUInterpolateExample methodsFor: 'testing' stamp: 'lr 7/4/2008 10:18'!
testArithmetic
	self assert: '{1}' = '1'.
	self assert: '{1 + 2}' = '3'.
	self assert: '{10 factorial}' = '3628800'! !

!CUInterpolateExample methodsFor: 'testing' stamp: 'lr 4/17/2008 14:55'!
testClassVar
	ClassVar := 'abc'.
	self assert: '{ClassVar}' = 'abc'.
	self assert: 'x{ClassVar}' = 'xabc'.
	self assert: '{ClassVar}x' = 'abcx'.
	self assert: 'x{ClassVar}x' = 'xabcx'.
	
	ClassVar := 123.
	self assert: '{ClassVar}' = '123'.
	self assert: 'x{ClassVar}' = 'x123'.
	self assert: '{ClassVar}x' = '123x'.
	self assert: 'x{ClassVar}x' = 'x123x'! !

!CUInterpolateExample methodsFor: 'testing' stamp: 'lr 4/17/2008 14:54'!
testEmpty
	self assert: '' = ''.
	self assert: '' == ''! !

!CUInterpolateExample methodsFor: 'testing' stamp: 'lr 5/26/2008 15:38'!
testExample
	self assert: (self owner: 'Hans' object: 'computer' count: 1) = 'Hans owns 1 computer'.
	self assert: (self owner: 'Kurt' object: 'cow' count: 2) = 'Kurt owns 2 cows'! !

!CUInterpolateExample methodsFor: 'testing' stamp: 'lr 6/10/2008 22:23'!
testExample2
	| owner object count |
	owner := 'Hans'.
	count := 1.
	object := 'computer'.
	self assert: '{owner} owns {count} {object asPluralBasedOn: count}' = 'Hans owns 1 computer'! !

!CUInterpolateExample methodsFor: 'testing' stamp: 'lr 4/17/2008 14:53'!
testInstVar
	instVar := 'abc'.
	self assert: '{instVar}' = 'abc'.
	self assert: 'x{instVar}' = 'xabc'.
	self assert: '{instVar}x' = 'abcx'.
	self assert: 'x{instVar}x' = 'xabcx'.
	
	instVar := 123.
	self assert: '{instVar}' = '123'.
	self assert: 'x{instVar}' = 'x123'.
	self assert: '{instVar}x' = '123x'.
	self assert: 'x{instVar}x' = 'x123x'! !

!CUInterpolateExample methodsFor: 'testing' stamp: 'lr 4/17/2008 14:54'!
testPlain
	self assert: 'abc' = 'abc'.
	self assert: 'abc' == 'abc'! !

!CUInterpolateExample methodsFor: 'testing' stamp: 'lr 4/17/2008 15:11'!
testSideEffect
	| x | 
	self assert: '{x := 1}' = '1'.
	self assert: '{x := x + 1}' = '2'.
	self assert: '{x := x + 2}' = '4'! !

!CUInterpolateExample methodsFor: 'testing' stamp: 'lr 4/17/2008 14:54'!
testTempVar
	| tempVar |
	
	tempVar := 'abc'.
	self assert: '{tempVar}' = 'abc'.
	self assert: 'x{tempVar}' = 'xabc'.
	self assert: '{tempVar}x' = 'abcx'.
	self assert: 'x{tempVar}x' = 'xabcx'.
	
	tempVar := 123.
	self assert: '{tempVar}' = '123'.
	self assert: 'x{tempVar}' = 'x123'.
	self assert: '{tempVar}x' = '123x'.
	self assert: 'x{tempVar}x' = 'x123x'! !

QQTestCase subclass: #CURegexExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Examples'!

!CURegexExample class methodsFor: 'transformations' stamp: 'lr 5/4/2010 09:06'!
highlightRegex
	<highlight>

	^ Array
		with: (CHTreePattern new
			verification: [ :node | node receiver value isString ];
			expression: '`#literal asRegex' do: TextEmphasis underlined;
			yourself)
		with: (CHTreePattern new
			verification: [ :node | node receiver value isString ];
			expression: '`#literal asRegexIgnoringCase' do: TextEmphasis underlined;
			yourself)! !

!CURegexExample class methodsFor: 'transformations' stamp: 'lr 4/2/2009 15:28'!
transformRegex
	<transform>

	^ Array
		with: (CHTreePattern new
			verification: [ :node | node receiver value isString ];
			expression: '`#literal asRegex' do: [ :context | 
				context node swapWith: context node receiver value asRegex lift ];
			yourself)
		with: (CHTreePattern new
			verification: [ :node | node receiver value isString ];
			expression: '`#literal asRegexIgnoringCase' do: [ :context | 
				context node swapWith: context node receiver value asRegexIgnoringCase lift ];
			yourself)! !

!CURegexExample methodsFor: 'testing' stamp: 'lr 4/17/2008 16:10'!
testAsRegex
	| regex |
	regex := 'abc' asRegex.
	self assert: (thisContext method literals
		anySatisfy: [ :each | each = regex ])! !

!CURegexExample methodsFor: 'testing' stamp: 'lr 4/17/2008 16:10'!
testAsRegexIgnoringCase
	| regex |
	regex := 'abc' asRegexIgnoringCase.
	self assert: (thisContext method literals
		anySatisfy: [ :each | each = regex ])! !

QQTestCase subclass: #CURomanExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Examples'!

CURomanExample class
	instanceVariableNames: 'arabicToRoman romanToArabic'!

CURomanExample class
	instanceVariableNames: 'arabicToRoman romanToArabic'!

!CURomanExample class methodsFor: 'utilties' stamp: 'lr 3/18/2009 09:32'!
arabicToRoman: anInteger
	"Convert an arabic integer to a roman string."
	
	| number roman |
	arabicToRoman isNil
		ifTrue: [ self initializeArabicToRoman ].
	number := anInteger.
	roman := WriteStream on: String new.
	arabicToRoman do: [ :pair |
		[ number >= pair first ] whileTrue: [
			roman nextPutAll: pair second.
			number := number - pair first ] ].
	^ roman contents! !

!CURomanExample class methodsFor: 'transformations' stamp: 'lr 4/2/2009 15:34'!
highlightRoman
	<highlight>

	^ CHTreePattern new
		verification: [ :node | (self romanToArabic: node name) notNil ];
		expression: '`var' do: (Array 
			with: (CHHighlightAttribute new
				color: (Color black alpha: 0.25);
				yourself)
			with: Color black);
		yourself! !

!CURomanExample class methodsFor: 'initialization' stamp: 'lr 3/18/2009 09:32'!
initializeArabicToRoman
	arabicToRoman := #((1000 'M') (900 'CM') (500 'D') (400 'CD') (100 'C') (90 'XC') (50 'L') (40 'XL') (10 'X') (9 'IX') (5 'V') (4 'IV') (1 'I'))! !

!CURomanExample class methodsFor: 'initialization' stamp: 'lr 3/18/2009 09:32'!
initializeRomanToArabic
	romanToArabic := Dictionary new
		at: $I put: 1;
		at: $V put: 5;
		at: $X put: 10;
		at: $L put: 50;
		at: $C put: 100;
		at: $D put: 500;
		at: $M put: 1000;
		yourself! !

!CURomanExample class methodsFor: 'utilties' stamp: 'lr 3/18/2009 09:32'!
romanToArabic: aString
	"Convert a roman string to an arabic integer, answer nil if not a roman number."
	
	| arabic last digit |
	romanToArabic isNil
		ifTrue: [ self initializeRomanToArabic ].
	arabic := 0. last := 1000.
	aString do: [ :each |
		digit := romanToArabic 
			at: each
			ifAbsent: [ ^ nil ].
		last < digit
			ifTrue: [ arabic := arabic - (2 * last) ].
		arabic := arabic + (last := digit) ].
	^ (self arabicToRoman: arabic) = aString
		ifTrue: [ arabic ]! !

!CURomanExample class methodsFor: 'transformations' stamp: 'lr 9/11/2010 13:49'!
transformRoman
	<transform>

	^ CHTreePattern new
		expression: '`var' do: [ :context |
			| arabic |
			arabic := self romanToArabic: context node name.
			arabic notNil
				ifTrue: [ context node replaceWith: (RBLiteralNode literalToken: (RBNumberLiteralToken value: arabic start: context node start stop: context node stop source: context node name)) ] ];
		yourself! !

!CURomanExample methodsFor: 'testing' stamp: 'lr 9/11/2010 13:49'!
testArithmetic
	self assert: CXXI + CXII = CCXXXIII.
	self assert: XVI + VII = XXIII.
	self assert: XVII - VI = XI.
	self assert: CXII * II = CCXXIV.
	self assert: CIV + VI = CX.
	self assert: MCMXCVI + XIV = MMX! !

!CURomanExample methodsFor: 'testing-utilities' stamp: 'lr 3/18/2009 09:33'!
testConvert
	| roman arabic |
	1 to: 4000 do: [ :each | 
		roman := self class arabicToRoman: each.
		self assert: roman isString.
		self assert: roman notEmpty.
		arabic := self class romanToArabic: roman.
		self assert: arabic isInteger.
		self assert: arabic = each ]! !

!CURomanExample methodsFor: 'testing-utilities' stamp: 'lr 3/18/2009 09:33'!
testInvalid
	| arabic |
	arabic := self class romanToArabic: 'A'.
	self assert: arabic isNil.
	
	arabic := self class romanToArabic: 'x'.
	self assert: arabic isNil! !

!CURomanExample methodsFor: 'testing' stamp: 'lr 3/18/2009 09:33'!
testValues
	self assert: I = 1.
	self assert: II = 2.
	self assert: III = 3.
	self assert: IV = 4.
	self assert: V = 5! !

QQTestCase subclass: #CUSwapExample
	instanceVariableNames: 'i1 i2'
	classVariableNames: 'C1 C2'
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Examples'!

!CUSwapExample class methodsFor: 'private' stamp: 'lr 4/26/2010 23:05'!
swap: a with: b
	"self astSwap: ``(x) with: ``(y)"
	
	^ ``[ | temp | temp := `,a. `,a := `,b. `,b := temp ] body! !

!CUSwapExample class methodsFor: 'transformations' stamp: 'lr 4/26/2010 23:08'!
transformAssign
	<transform>

	^ CHTreePattern new
		expression: '{ `@.target } <== { `@.source }' do: [ :context |
			| source target |
			source := context @ '`@.source'.
			target := context @ '`@.target'.
			(source size = target size 
				and: [ target allSatisfy: [ :each | each isVariable ] ]) ifTrue: [
					| sequence |
					sequence := RBSequenceNode new.
					source with: target do: [ :expression :variable |
						sequence addNode: (RBAssignmentNode variable: variable value: expression) ].
					context node swapWith: sequence ] ];
		yourself! !

!CUSwapExample class methodsFor: 'transformations' stamp: 'lr 4/26/2010 23:05'!
transformSwap
	<transform>

	^ CHTreePattern new
		expression: '`source <==> `target' do: [ :context |
			context node swapWith: (self 
				swap: context node receiver
				with: context node arguments first) ];
		yourself! !

!CUSwapExample methodsFor: 'testing-assign' stamp: 'lr 12/14/2009 10:40'!
testAssignClassVars
	{ C1. C2 } <== { 1. 2 }.
	self assert: C1 = 1.
	self assert: C2 = 2! !

!CUSwapExample methodsFor: 'testing-assign' stamp: 'lr 12/14/2009 10:38'!
testAssignInstVars
	{ i1. i2 } <== { 1. 2 }.
	self assert: i1 = 1.
	self assert: i2 = 2! !

!CUSwapExample methodsFor: 'testing-assign' stamp: 'lr 12/14/2009 10:40'!
testAssignTempVars
	| t1 t2 |
	{ t1. t2 } <== { 1. 2 }.
	self assert: t1 = 1.
	self assert: t2 = 2! !

!CUSwapExample methodsFor: 'testing-swap' stamp: 'lr 12/14/2009 10:39'!
testSwapClassVars
	C1 := 1.
	C2 := 2.
	
	C1 <==> C2.
	
	self assert: C1 = 2.
	self assert: C2 = 1! !

!CUSwapExample methodsFor: 'testing-swap' stamp: 'lr 12/14/2009 10:39'!
testSwapInstVars
	i1 := 1.
	i2 := 2.
	
	i1 <==> i2.
	
	self assert: i1 = 2.
	self assert: i2 = 1! !

!CUSwapExample methodsFor: 'testing-swap' stamp: 'lr 12/14/2009 10:39'!
testSwapTempVars
	| t1 t2 |
	t1 := 1.
	t2 := 2.
	
	t1 <==> t2.
	
	self assert: t1 = 2.
	self assert: t2 = 1! !

QQTestCase subclass: #CUTypeExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Examples'!

!CUTypeExample class methodsFor: 'private' stamp: 'lr 8/5/2008 14:06'!
assert: anObject type: aClass name: aString
	"Assert anObject is of type aClass. Use aString to give the user an appropriate error message. Answer anObject."
	
	(anObject isKindOf: aClass)
		ifFalse: [ self error: aString , ' expected to be of type ' , aClass name ].
	^ anObject! !

!CUTypeExample class methodsFor: 'transformations' stamp: 'lr 4/26/2010 23:13'!
transformArguments
	<transform>

	| type |
	^ [ :context |
		context tree arguments reverseDo: [ :each |
			(type := self typeOf: each name) isNil ifFalse: [
				context tree body addNodeFirst: ``(self class 
					assert: `,each type: `,type name: `,(each name)) ] ] ]! !

!CUTypeExample class methodsFor: 'transformations' stamp: 'lr 4/26/2010 23:23'!
transformReturn
	<transform>

	| pragma type |
	^ CHConditionPattern new
		if: [ :context |
			(pragma := context pragmaNamed: #return:) notNil
				and: [ (type := self typeOf: pragma arguments first value) notNil ] ]
		then: (CHTreePattern new
			expression: '^ ``@expr';
			at: '``@expr' do: [ :context |
				context node replaceWith: ``(self class 
					assert: `,(context node) type: `,type name: 'return value') ])! !

!CUTypeExample class methodsFor: 'private' stamp: 'lr 4/26/2010 23:23'!
typeOf: aString
	"Answer the class encoded in the given string. Prefixes and postfixes are corpped if possible. If no meaningful class is found, nil is returned."

	| start stop |
	start := aString findFirst: [ :each | each isUppercase ].
	start isZero ifTrue: [ start := 1 ].
	stop := aString findLast: [ :each | each isLetter ].
	stop isZero ifTrue: [ stop := aString size ].
	^ start < stop 
		ifTrue: [ Smalltalk classNamed: (aString copyFrom: start to: stop) ]! !

!CUTypeExample methodsFor: 'mocks' stamp: 'lr 8/5/2008 13:48'!
+ anInteger! !

!CUTypeExample methodsFor: 'mocks' stamp: 'lr 8/5/2008 13:49'!
pnt: aPoint int: anInteger! !

!CUTypeExample methodsFor: 'mocks' stamp: 'lr 4/26/2010 23:23'!
ret: aNumber
	<return: Integer>
	
	aNumber negative
		ifTrue: [ ^ aNumber ]
		ifFalse: [ ^ aNumber negated ]! !

!CUTypeExample methodsFor: 'testing' stamp: 'lr 8/5/2008 14:44'!
testBinaryMessage
	self + 123.
	self + 123 factorial.
	self 
		should: [ self + 1.23 ]
		raise: Error! !

!CUTypeExample methodsFor: 'testing' stamp: 'lr 8/5/2008 14:44'!
testKeywordMessage
	self pnt: 1 @ 2 int: 123.
	self pnt: 1 @ 2 int: 123 factorial.
	self 
		should: [ self pnt: 1 int: 123 ]
		raise: Error.
	self 
		should: [ self pnt: 1 @ 2 int: 1.23 ]
		raise: Error! !

!CUTypeExample methodsFor: 'testing' stamp: 'lr 8/5/2008 15:09'!
testReturn
	self ret: 123.
	self ret: -123.
	self 
		should: [ self ret: 1.23 ]
		raise: Error.
	self 
		should: [ self ret: -1.23 ]
		raise: Error! !

CURaisedToFixture subclass: #CURaisedToExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Examples'!

!CURaisedToExample methodsFor: 'testing' stamp: 'lr 4/17/2008 11:48'!
testMatch
	self assert: (2 raisedTo: -3) = (1/8).
	self assert: (2 raisedTo: -1) = (1/2).
	self assert: (2 raisedTo: 0) = 1.
	self assert: (2 raisedTo: 1) = 2.
	self assert: (2 raisedTo: 5) = 32.
	self assert: (2 raisedTo: 16) =  65536! !

!CURaisedToExample methodsFor: 'testing' stamp: 'lr 8/13/2008 13:44'!
testParse
	self assert: (self class raise: ``(x) to: -3)
		= (self parse: '1 / (x * x * x)').
	self assert: (self class raise: ``(x) to: -1)
		= (self parse: '1 / x').
	self assert: (self class raise: ``(x) to: 0)
		= (self parse: '1').
	self assert: (self class raise: ``(x) to: 1)
		= (self parse: 'x').
	self assert: (self class raise: ``(x) to: 5)
		= (self parse: 'x * x * x * x * x')! !

!CURaisedToExample methodsFor: 'testing' stamp: 'lr 8/13/2008 13:42'!
testSplice
	self assert: `@(self raise: 2 to: -3) = (1/8).
	self assert: `@(self raise: 2 to: -1) = (1/2).
	self assert: `@(self raise: 2 to: 0) = 1.
	self assert: `@(self raise: 2 to: 1) = 2.
	self assert: `@(self raise: 2 to: 5) = 32.
	self assert: `@(self raise: 2 to: 16) =  65536! !

!CURaisedToExample methodsFor: 'testing' stamp: 'lr 4/17/2008 11:48'!
testTempVar
	| x |
	x := 2.
	self assert: (x raisedTo: -3) = (1/8).
	self assert: (x raisedTo: -1) = (1/2).
	self assert: (x raisedTo: 0) = 1.
	self assert: (x raisedTo: 1) = 2.
	self assert: (x raisedTo: 5) = 32.
	self assert: (x raisedTo: 16) =  65536! !

Object subclass: #CUBrainfuckExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Examples'!

!CUBrainfuckExample class methodsFor: 'helvetia' stamp: 'lr 5/4/2010 08:58'!
compileBrainfuck
	"Details on the Brainfuck language can be found here: <http://en.wikipedia.org/wiki/Brainfuck>."
	<parse>

	| method doit statement statements incrementPointer decrementPointer increment decrement output input loop other |
	method := PPUnresolvedParser new.
	doit := PPUnresolvedParser new.
	statement := PPUnresolvedParser new.	
	statements := statement star ==> [ :nodes | RBSequenceNode statements: (nodes reject: [ :each | each isNil ]) ].

	incrementPointer := $> asParser token ==> [ :token | ``(bf incrementPointer) nodesDo: [ :n | n rangeStart: token start; rangeStop: token stop ] ].
	decrementPointer := $< asParser token ==> [ :token | ``(bf decrementPointer) nodesDo: [ :n | n rangeStart: token start; rangeStop: token stop ] ].
	increment := $+ asParser token ==> [ :token | ``(bf incrementValue) nodesDo: [ :n | n rangeStart: token start; rangeStop: token stop ] ].
	decrement := $- asParser token ==> [ :token | ``(bf decrementValue) nodesDo: [ :n | n rangeStart: token start; rangeStop: token stop ] ].
	output := $. asParser token ==> [ :token | ``(bf outputValue) nodesDo: [ :n | n rangeStart: token start; rangeStop: token stop ] ].
	input := $, asParser token ==> [ :token | ``(bf inputValue) nodesDo: [ :n | n rangeStart: token start; rangeStop: token stop ] ].
	loop := $[ asParser token , statements , $] asParser token ==> [ :nodes | ``(bf repeat: [ `,(nodes second) ]) ].
	other := $] asParser negate token ==> [ :nodes | nil ].

	method def: #letter asParser plus token , statements end ==> [ :nodes | 
		(RBMethodNode selectorParts: (Array with: nodes first) arguments: #())
			body: (nodes second
				temporaries: { ``bf };
				addNodesFirst: { ``(bf := CUBrainfuckMachine new) };
				yourself);
			yourself ].
	doit def: statements end.
	statement def: (incrementPointer 
		/ decrementPointer 
		/ increment 
		/ decrement 
		/ output 
		/ input 
		/ loop 
		/ other).
		
	^ [ :context |
		(context isDoIt ifTrue: [ doit ] ifFalse: [ method ])
			parse: context stream ]! !

!CUBrainfuckExample class methodsFor: 'demoing' stamp: 'lr 9/11/2010 13:29'!
debug
	"CUBrainfuckExample debug"

	| brainfuck process debugger |
	brainfuck := self new.
	process := [ brainfuck hello ]
		newProcess.
	4 timesRepeat: [ process step ].
	4 timesRepeat: [ process completeStep: process suspendedContext ].
	debugger := Smalltalk classNamed: #OTDebugger.
	debugger isNil
		ifFalse: [ 
			debugger 
				openProcess: process
				context: process suspendedContext
				label: 'Brainfuck Debugger'
				errorWasInUIProcess: false ]
		ifTrue: [
			Debugger
				openOn: process 
				context: process suspendedContext
				label: 'Brainfuck Debugger' 
				contents: nil 
				fullView: true ]! !

!CUBrainfuckExample class methodsFor: 'helvetia' stamp: 'lr 4/2/2009 21:04'!
hightlightBrainfuck
	<highlight>

	^ Array
		with: (CHMatchPattern new 			" comments "
			expression: '.+'
			do: Color green muchDarker)
		with: (CHMatchPattern new			" pointer "
			expression: '[<>]+'
			do: Color black)
		with: (CHMatchPattern new			" arithmetic "
			expression: '[+\-]+'
			do: Color blue)
		with: (CHMatchPattern new			" input/output "
			expression: '[.,]+'
			do: Color magenta)
		with: (CHMatchPattern new			" looping "
			expression: '(\[|\])+'
			do: (Array 
				with: TextEmphasis bold
				with: Color black))! !

!CUBrainfuckExample class methodsFor: 'helvetia' stamp: 'lr 3/27/2009 17:41'!
hightlightSmalltalk80	
	^ nil! !

!CUBrainfuckExample methodsFor: 'arithmetic' stamp: 'lr 3/27/2009 17:41'!
addition
	This program adds two single-digit numbers and displays the result correctly if it too has only one digit
	
	,>++++++[<-------->-],[<+>-]<.! !

!CUBrainfuckExample methodsFor: 'others' stamp: 'lr 3/27/2009 17:39'!
convert
	This will take lowercase input from the keyboard and make it uppercase
	To exit press enter
	
	,----------[----------------------.,----------]! !

!CUBrainfuckExample methodsFor: 'arithmetic' stamp: 'lr 3/27/2009 17:39'!
division
	,>,>++++++[-<--------<-------->>]		Store 2 numbers from keyboard in (0) and (1); and subtract 48 from each
	<<[								This is the main loop which continues until the dividend in (0) is zero
	>[->+>+<<]							Destructively copy the divisor from (1) to (2) and (3); setting (1) to zero
	>[-<<-							Subtract the divisor in (2) from the dividend in (0); the difference is stored in (0) and (2) is cleared
	[>]>>>[<[>>>-<<<[-]]>>]<<]				If the dividend in (0) is zero; exit the loop
	>>>+								Add one to the quotient in (5)
	<<[-<<+>>]							Destructively copy the divisor in (3) to (1)
	<<<]								Move the stack pointer to (0) and go back to the start of the main loop
	>[-]>>>>[-<<<<<+>>>>>]				Destructively copy the quotient in (5) to (0) (not necessary; but cleaner)
	<<<<++++++[-<++++++++>]<.			Add 48 and print result! !

!CUBrainfuckExample methodsFor: 'others' stamp: 'lr 3/27/2009 17:39'!
echo
	A continuous loop that takes text input from the keyboard and echoes it to the screen (similar to the Unix cat program)
	
	,[.,]! !

!CUBrainfuckExample methodsFor: 'others' stamp: 'lr 3/27/2009 17:39'!
hello
	The following program prints "Hello World" on the transcript

	++++++++++							initialises cell zero to 10
	[>+++++++>++++++++++>+++>+<<<<-]		this loop sets the next four cells to 70/100/30/10 
	>++.									print 'H'
	>+.									print 'e'
	+++++++.								print 'l'
	.									print 'l'
	+++.									print 'o'
	>++.									print space
	<<+++++++++++++++.					print 'W'
	>.									print 'o'
	+++.									print 'r'
	------.								print 'l'
	--------.								print 'd'
	>+.									print '!!'! !

!CUBrainfuckExample methodsFor: 'arithmetic' stamp: 'lr 3/27/2009 17:39'!
multiplication
	This program multiplies two single-digit numbers and displays the result correctly if it too has only one digit
	
	,>,>++++++++[<------<------>>-]
	<<[>[>+>+<<-]>>[<<+>>-]<<<-]
	>>>++++++[<++++++++>-]<.>! !

Object subclass: #CUBrainfuckMachine
	instanceVariableNames: 'data pointer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Examples'!

!CUBrainfuckMachine methodsFor: 'actions' stamp: 'lr 2/9/2009 16:06'!
decrementPointer
	"Decrement the data pointer to point to the next cell to the right."
	
	
	pointer > 1
		ifTrue: [ pointer := pointer - 1 ]
		ifFalse: [ self error: 'Invalid machine state.' ]! !

!CUBrainfuckMachine methodsFor: 'actions' stamp: 'lr 2/9/2009 15:22'!
decrementValue
	"Decrease the value at the current cell by one."
	
	data at: pointer put: (data at: pointer) - 1! !

!CUBrainfuckMachine methodsFor: 'private' stamp: 'lr 2/9/2009 15:48'!
grow
	data := data , (Array new: data size withAll: 0)! !

!CUBrainfuckMachine methodsFor: 'actions' stamp: 'lr 2/9/2009 16:09'!
incrementPointer
	"Increment the data pointer to point to the next cell to the right."
	
	pointer := pointer + 1.
	data size < pointer
		ifTrue: [ data addLast: 0 ]! !

!CUBrainfuckMachine methodsFor: 'actions' stamp: 'lr 2/9/2009 15:22'!
incrementValue
	"Increase the value at the current cell by one."
	
	data at: pointer put: (data at: pointer) + 1! !

!CUBrainfuckMachine methodsFor: 'initialization' stamp: 'lr 2/9/2009 16:09'!
initialize
	data := OrderedCollection with: 0.
	pointer := 1! !

!CUBrainfuckMachine methodsFor: 'actions' stamp: 'lr 2/9/2009 15:59'!
inputValue
	"Accept one byte of input, storing its value in the byte at the data pointer."

	Processor yield.
	[ Sensor keyboardPressed ] whileFalse.
	data at: pointer put: Sensor keyboard asInteger! !

!CUBrainfuckMachine methodsFor: 'actions' stamp: 'lr 2/9/2009 15:55'!
outputValue
	"Output the value of the byte at the data pointer."

	| value |
	value := data at: pointer.
	value < 0 ifTrue: [ ^ self ].
	Transcript show: (Character value: value); flush! !

!CUBrainfuckMachine methodsFor: 'printing' stamp: 'lr 2/9/2009 16:17'!
printOn: aStream
	(1 to: data size)
		do: [ :index | 
			index = pointer
				ifFalse: [ aStream print: (data at: index) ]
				ifTrue: [ aStream nextPut: $[; print: (data at: index); nextPut: $] ] ]
		separatedBy: [ aStream space ]! !

!CUBrainfuckMachine methodsFor: 'actions' stamp: 'lr 2/9/2009 15:44'!
repeat: aBlock
	[ (data at: pointer) == 0 ]
		whileFalse: [ aBlock value ]! !

Object subclass: #CUHighlightExample
	instanceVariableNames: ''
	classVariableNames: 'DSLClickAction DSLMatchPattern'
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Examples'!

!CUHighlightExample class methodsFor: 'rules' stamp: 'lr 9/2/2010 11:10'!
htmlTagsInString
	<highlight>
	
	^ CHTreePattern new
		verification: [ :node | node value isString and: [ node value isSymbol not ] ];
		expression: '`#literal' do: (Array
			with: Color black
			with: (CHMatchPattern new
				expression: '((https?|s?ftp|ftps|file|smb|afp|nfs|gopher)\://|mailto\:)[-:@a-zA-Z0-9_.,~%+/?=&#]+'
				do: (Array 
					with: TextEmphasis underlined
					with: (CHClickAction on: [ :context | self inform: context scopedString. nil ])))
			with: (CHMatchPattern new
				expression: '</?(\w+)\s*([^>]*)>' do: Color blue;
				at: 2 do: TextEmphasis bold;
				at: 3 do: (CHMatchPattern new
					expression: '(\w+)=("[^"]*")';
					at: 3 do: TextColor magenta))
			with: (CHRangePattern new
				begin: '<!!--'; end: '-->';
				outer: (Color r: 0 g: 0.5 b: 0)))! !

!CUHighlightExample methodsFor: 'examples' stamp: 'lr 2/17/2009 11:31'!
otherHtmlString
	^ '<!!-- some html string -->
	<div id="12" class="foo"><div href="foo">
		<a href="http://www.google.ch">Google</a>
		<!!-- more content -->
	</div>'! !

!CUHighlightExample methodsFor: 'examples' stamp: 'lr 2/17/2009 11:33'!
someHtmlString
	^ '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
		<meta name="keywords" content="Diesel, SCG, Software Composition Group, University of Bern, SmallWiki, Smalltalk" />
		<meta name="description" content="Diesel" />
		<meta name="author" content="Software Composition Group" />
		<link type="application/rss+xml" rel="alternate" href="http://smallwiki.unibe.ch/diesel/?action=RSSChangesFeed" title="RSS" />
		<meta name="robots" content="index,follow" />
		<title>SCG Wiki: Diesel</title>
		<base href="http://smallwiki.unibe.ch/" />
		<style type="text/css">@import "http://www.iam.unibe.ch/~scg/smallwiki/thepixelisdead/style.css";</style>
	</head>
	<body>
		<div id="container">
			<div id="title">
				<div class="begin"></div>
				<h1>Diesel</h1><div class="end">
			</div>
		</div>
	</body>
</html>'! !

Object subclass: #CULintExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-Helvetia-Examples'!

CULintExample class
	instanceVariableNames: 'lintRules spellRules transformRules'!

CULintExample class
	instanceVariableNames: 'lintRules spellRules transformRules'!

!CULintExample class methodsFor: 'private' stamp: 'lr 9/2/2010 11:08'!
buildLintRules
	| highlight |
	highlight := Array 
		with: (CHHighlightAttribute new
			borderColorBottom: (CHHighlightAttribute wave: Color orange height: 3);
			borderWidthBottom: 3;
			outline: 2;
			yourself)
		with: (CHGutterAttribute warning).
	^ (RBCompositeLintRule rulesFor: RBParseTreeLintRule) collect: [ :rule | [ :context |
		(rule matcher executeTree: context scopedTree initialAnswer: nil) ifNotNil: [ :node |
			context scopeNode: node with: nil visit: highlight ] ] ]! !

!CULintExample class methodsFor: 'private' stamp: 'lr 4/2/2009 15:34'!
buildSpellRules
	| class highlight |
	class := Smalltalk classNamed: #RBSpellChecker.
	class isNil ifTrue: [ ^ Array new ].
	highlight := CHHighlightAttribute new
		borderColorBottom: (CHHighlightAttribute wave: Color red height: 3);
		borderWidthBottom: 3;
		outline: 2;
		yourself.
	^ [ :context |
		(RBSpellChecker default check: context string) do: [ :word |
			| index |
			index := 0.
			[	index := context string 
					findString: word 
					startingAt: index + 1
					caseSensitive: false.
				index > 0 ifTrue: [
					context
						scopeFrom: index 
						to: index + word size - 1 
						with: nil 
						visit: highlight ].
				index between: 1 and: context string size ]
					whileTrue ] ]! !

!CULintExample class methodsFor: 'private' stamp: 'lr 4/2/2009 15:34'!
buildTransformRules
	| highlight |
	highlight := Array
		with: (CHHighlightAttribute new
			borderColorBottom: (CHHighlightAttribute wave: Color blue height: 3);
			borderWidthBottom: 3;
			outline: 2;
			yourself)
		with: (CHGutterAttribute warning).
	^ (RBCompositeLintRule rulesFor: RBTransformationRule) gather: [ :rule | 
		rule rewriteRule searches collect: [ :search |
			CHTreePattern new searchTree: search searchTree do: (Array
				with: highlight 
				with: (CHClickAction new do: [ :context :model |
					((rule setClass: context theClass; rewriteRule) executeTree: context node) ifTrue: [
						context node replaceWith: rule rewriteRule tree.
						context tree printString ] ])) ] ]! !

!CULintExample class methodsFor: 'rules' stamp: 'lr 4/2/2009 13:13'!
lintRules
	<highlight>
	
	^ lintRules ifNil: [ lintRules := self buildLintRules ]! !

!CULintExample class methodsFor: 'private' stamp: 'lr 4/2/2009 13:16'!
reset
	lintRules := spellRules := transformRules := nil! !

!CULintExample class methodsFor: 'rules' stamp: 'lr 4/2/2009 13:13'!
spellRules
	<highlight>
	
	^ spellRules ifNil: [ spellRules := self buildSpellRules ]! !

!CULintExample class methodsFor: 'rules' stamp: 'lr 4/2/2009 13:13'!
transformRules
	<highlight>
	
	^ transformRules ifNil: [ transformRules := self buildTransformRules ]! !

!CULintExample methodsFor: 'examples' stamp: 'lr 4/2/2009 15:54'!
crypticCode
	| x |
	x := 12.
	x > 0 ifTrue: [ x := 0 ].
	x < 0 ifTrue: [ x := 0 ].
	1 <= x and: [ x <= 12 ]! !

!CULintExample methodsFor: 'examples' stamp: 'lr 4/2/2009 12:15'!
selfAndSuper
	self asString.
	super asString! !

!CULintExample methodsFor: 'examples' stamp: 'lr 4/2/2009 13:33'!
spellChecking
	^ #( weighted wagted inefficient ineffiect immediately imidatly )! !

!CULintExample methodsFor: 'examples' stamp: 'lr 4/3/2009 17:39'!
unknownMessage
	Object asNumber! !

!CULintExample methodsFor: 'examples' stamp: 'lr 4/2/2009 12:15'!
yourselfMissing
	^ OrderedCollection new
		add: 12;
		add: 13! !
